part of katana_module;

/// FormConfig for using birthday DropdownField.
@immutable
class BirthdaySelectFormConfig extends FormConfig {
  const BirthdaySelectFormConfig({
    this.backgroundColor,
    this.initialDate,
    this.color,
  });

  static const String _type = "birthdaySelect";

  final DateTime? initialDate;

  final Color? backgroundColor;

  final Color? color;

  static BirthdaySelectFormConfig? _fromMap(DynamicMap map) {
    final initialDate = map.get<int?>("initialDate", null);
    return BirthdaySelectFormConfig(
      backgroundColor: map.getAsMap("backgroundColor").toColor(),
      color: map.getAsMap("color").toColor(),
      initialDate: initialDate != null
          ? DateTime.fromMillisecondsSinceEpoch(initialDate)
          : null,
    );
  }

  /// Convert the form config to [DynamicMap].
  @override
  DynamicMap toMap() {
    return <String, dynamic>{
      "type": _type,
      "backgroundColor": backgroundColor.toMap(),
      "color": color.toMap(),
      if (initialDate != null)
        "initialDate": initialDate!.millisecondsSinceEpoch,
    };
  }
}
